/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gebietsbaum;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gebietsbaum.boundary.AbstractStrasseneintragSearchParameters;
import de.ivu.elect.business.gebietsbaum.boundary.StrasseneintragChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.StrasseneintragConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.StrasseneintragExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.StrasseneintragSearch;
import de.ivu.elect.business.gebietsbaum.boundary.StrasseneintragSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Strasseneintrag;
import de.ivu.elect.business.gebietsbaum.entity.StrasseneintragMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStrasseneintragSearchView.COMPONENT_NAME)
@View(viewId = AbstractStrasseneintragSearchView.VIEW_ID, useCase = UseCasePermission.STRASSENEINTRAG_SEARCH)
public abstract class AbstractStrasseneintragSearchView extends AbstractElectSearchView<Strasseneintrag> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "strasseneintragSearchView";
  
  public static final String VIEW_ID = "/gebietsbaum/strasseneintrag-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStrasseneintragSearchView requestHandler;

  @Inject
  private transient StrasseneintragExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StrasseneintragConversationStore.class)
  protected transient StrasseneintragConversationStore conversationStore;

  @Inject
  protected transient StrasseneintragSearch search;

  @Inject
  @ConversationGroup(AbstractStrasseneintragSearchParameters.class)
  protected transient StrasseneintragSearchParameters searchParameters;

  @Inject
  protected transient StrasseneintragMeta entityMeta;

  public AbstractStrasseneintragSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Strasseneintrag getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Strasseneintrag entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StrasseneintragSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Strasseneintrag> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Strasseneintrag> create();
  }

  @Override
  public List<Strasseneintrag> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Strasseneintrag> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStrasseneintragChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StrasseneintragChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStrasseneintragSearchView {

    @View
    @Inject
    private transient Instance<AbstractStrasseneintragSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStrasseneintragSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
